$TVRemote::EventCount = 6;
for(%i = 0; %i < $TVRemote::EventCount; %i++)
{
   echo("added tv remote event "@%i);
   registerInputEvent(fxDTSBrick,"onTVSelect"@%i,"Self fxDTSBrick" TAB "Player player" TAB "Client GameConnection" TAB "MiniGame Minigame");
   eval("function fxDTSBrick::onTVSelect"@%i@"(%brick,%player){$InputTarget_[\"Self\"] = %brick;$InputTarget_[\"Player\"] = %player;$InputTarget_[\"Client\"] = %player.client;$InputTarget_[\"MiniGame\"] = getMiniGameFromObject(%brick);%brick.processInputEvent(onTVSelect"@%i@");}");
}
datablock ParticleData(TVRemoteParticle)
 {
   dragCoefficient      = 3;
   gravityCoefficient   = -0.0;
   inheritedVelFactor   = 1.0;
   constantAcceleration = 0.0;
   lifetimeMS           = 200;
   lifetimeVarianceMS   = 0;
   textureName          = "base/data/particles/thinRing";
   spinSpeed		   = 0.0;
   spinRandomMin		= 0.0;
   spinRandomMax		= 0.0;
   colors[0]     = "1 1 1 0.9";
   colors[1]     = "1 1 1 0.5";
   colors[2]     = "1 1 1 0";

   sizes[0]      = 0.5;
   sizes[1]      = 0.35;
   sizes[2]      = 0.2;

   times[0] = 0.0;
   times[1] = 0.5;
   times[2] = 1.0;

   useInvAlpha = false;
};
datablock ParticleEmitterData(TVRemoteEmitter)
{
   ejectionPeriodMS = 15;
   periodVarianceMS = 1;
   ejectionVelocity = 0.25;
   velocityVariance = 0.0;
   ejectionOffset   = 0.0;
   thetaMin         = 0;
   thetaMax         = 90;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "TVRemoteParticle";

   useEmitterColors = true;

   uiName = "Radio Wave Trail";
};

datablock ProjectileData(tvRemoteProjectile)
{
   projectileShapeName = "base/data/shapes/empty.dts";
   explosion           = "";
   particleEmitter     = TVRemoteEmitter;
   explodeOnDeath = true;

   brickExplosionRadius = 0;
   brickExplosionImpact = 0;             //destroy a brick if we hit it directly?
   brickExplosionForce  = 0;             
   brickExplosionMaxVolume = 0;          //max volume of bricks that we can destroy
   brickExplosionMaxVolumeFloating = 0;  //max volume of bricks that we can destroy if they aren't connected to the ground (should always be >= brickExplosionMaxVolume)

   collideWithPlayers = false;

   sound = "";

   muzzleVelocity      = 65;
   velInheritFactor    = 1.0;

   armingDelay         = 0;
   lifetime            = 30000;
   fadeDelay           = 29500;
   bounceElasticity    = 0.99;
   bounceFriction      = 0.00;
   isBallistic         = true;
   gravityMod          = 0.0;

   hasLight    = true;
   lightRadius = 1.0;
   lightColor  = "1.0 1.0 0.5";

   uiName = "TVRemote Projectile"; 
};
datablock ItemData(TVRemoteItem)
{
	category = "Weapon";  // Mission editor category
	className = "Weapon"; // For inventory system

	 // Basic Item Properties
	shapeFile = "./remote.dts";
	rotate = false;
	mass = 1;
	density = 0.2;
	elasticity = 0.2;
	friction = 0.6;
	emap = true;

	//gui stuff
	uiName = "TV Remote";
	iconName = "./icon_gun";
	doColorShift = false;

	image = tvRemoteImage;
	canDrop = true;
};

datablock ShapeBaseImageData(tvRemoteImage)
{
   // Basic Item properties
   shapeFile = "./remote.dts";
   emap = true;

   mountPoint = 0;
   offset = "0 0 0";
   eyeOffset = 0; //"0.7 1.2 -0.5";
   rotation = eulerToMatrix( "0 0 0" );

   correctMuzzleVector = true;

   className = "WeaponImage";

   // Projectile && Ammo.
   item = tvRemoteItem;
   ammo = " ";
   projectile = tvRemoteProjectile;
   projectileType = Projectile;

   melee = false;
   armReady = true;

   doColorShift = false;

	stateName[0]                     = "Activate";
	stateTimeoutValue[0]             = 0.15;
	stateTransitionOnTimeout[0]       = "Ready";

	stateName[1]                     = "Ready";
	stateTransitionOnTriggerDown[1]  = "Fire";
	stateAllowImageChange[1]         = true;
	stateSequence[1]	= "Ready";

	stateName[2]                    = "Fire";
	stateTransitionOnTimeout[2]     = "Ready";
	stateTimeoutValue[2]            = 0.14;
	stateFire[2]                    = true;
	stateAllowImageChange[2]        = false;
	stateSequence[2]                = "Fire";
	stateScript[2]                  = "onFire";
	stateWaitForTimeout[2]			= true;

};
function TVRemoteImage::onFire(%this,%obj,%slot)
{
   parent::onFire(%this,%obj,%slot);
   %tar = %obj.GetTVRemoteTarget(20);
   if(!isObject(%tar))
      return;
   if(%tar.getClassName() $= "fxDTSBrick")
      %obj.doTVRemoteSelection(%tar);
}
function Player::doTVRemoteSelection(%this,%object)
{
   %this.tvchannel = mfloor(%this.tvchannel);
   %this.tvChannel = (%this.tvChannel+1) % ($TVRemote::EventCount);
   eval("%object.onTVSelect"@%this.tvChannel@"(%this);");
}
function Player::GetTVRemoteTarget(%this,%dist)
{
    %start = %this.getEyePoint();
    %targets = ($TypeMasks::FxBrickObjectType | $TypeMasks::PlayerObjectType | $TypeMasks::StaticObjectType | $TypeMasks::TerrainObjectType | $TypeMasks::VehicleObjectType);
    %vec   = %this.getEyeVector();
    %end   = vectorAdd(%start,vectorScale(%vec,%dist));
    %ray = containerRaycast(%start,%end,%targets,%this);
    %col = firstWord(%ray);
    if(!isObject(%col))
      return -1;
    return %col;
}